import hashlib
import random

def sqrt_binary_search_int(s, precision=80):
    if s < 0:
        raise ValueError("负数没有实数平方根")
    if s == 0 or s == 1:
        return str(s).ljust(precision + 2, '0')
    
    scale = 10 ** (precision * 2)
    s_scaled = s * scale
    
    low = 0
    high = s_scaled
    while low <= high:
        mid = (low + high) // 2
        if mid * mid == s_scaled:
            result = mid
            break
        elif mid * mid < s_scaled:
            low = mid + 1
            result = mid
        else:
            high = mid - 1
    
    result_str = str(result)
    result_str = result_str.zfill(precision + 1)
    decimal_part = result_str[-precision:]
    
    sqrt_str = f"{decimal_part}"
    
    return sqrt_str

t = random.randint(1000000000, 9999999999) * 10**10 + random.randint(1000000000, 9999999999)
flag = "flag{" + hashlib.md5(str(t).encode()).hexdigest() + "}"
s = sqrt_binary_search_int(t)
print(t)
print("s =", s)
print(flag)